--- linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tx-device.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tx-device.c	2014-11-28 12:39:00.572447000 +0800
@@ -0,0 +1,845 @@
+/* Name: mausb_tx_device.c 
+ * Description: implements MA USB transfers on device side 
+ * 
+ * This file is provided under a dual BSD/GPLv2 license. When using or 
+ * redistributing this file, you may do so under either license. 
+ * 
+ * GPL LICENSE SUMMARY 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * This program is free software; you can redistribute it and/or modify it 
+ * under the terms of version 2 of the GNU General Public License as published 
+ * by the Free Software Foundation. 
+ * 
+ * This program is distributed in the hope that it will be useful, but 
+ * WITHOUT ANY WARRANTY; without even the implied warranty of 
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
+ * General Public License for more details. 
+ * 
+ * Contact Information: 
+ * Sean Stalley, sean.stalley [at] intel 
+ * Stephanie Wallick, stephanie.s.wallick [at] intel 
+ * 2111 NE 25th Avenue 
+ * Hillsboro, Oregon 97124 
+ * 
+ * BSD LICENSE 
+ * 
+ * Copyright(c) 2014 Intel Corporation. 
+ * 
+ * Redistribution and use in source and binary forms, with or without 
+ * modification, are permitted provided that the following conditions 
+ * are met: 
+ * 
+ * Redistributions of source code must retain the above copyright 
+ notice, this list of conditions and the following disclaimer. 
+ * Redistributions in binary form must reproduce the above copyright 
+ notice, this list of conditions and the following disclaimer in 
+ the documentation and/or other materials provided with the 
+ distribution. 
+ * Neither the name of Intel Corporation nor the names of its 
+ contributors may be used to endorse or promote products derived 
+ from this software without specific prior written permission. 
+ 
+ * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
+ * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
+ * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR 
+ * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
+ * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
+ * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
+ * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY 
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
+ * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
+ */ 
+ 
+#include "mausb_hcd.h" 
+#include "mausb_udc.h" 
+#include "mausb_pkt.h" 
+#include "mausb_tx.h" 
+ 
+#include <linux/kthread.h> 
+ 
+int device_transfer_timeout(void *data) 
+{ 
+ struct mausb_host_ep *ep = (struct mausb_host_ep *) data; 
+ struct mausb_udc *udc = mausb_host_ep_to_maudc(ep); 
+ 
+ while (!kthread_should_stop()) { 
+ /* 
+ * make sure actual transfer timeout (i.e. not thread 
+ * setup) 
+ */ 
+ if (ep->tx_timed_out) { 
+ if (ep->state.retry_counter > 0) { 
+ maudc_dbg(udc, "%s: device timed out," 
+ " resending packet %i\n", 
+ __func__, ep->state.seq_number); 
+ 
+ device_OUT_send_txResp( 
+ &ep->active_transfer->state, 
+ &ep->state, 
+ ep->state.active_request_id, 
+ ep->state.seq_number, 
+ SUCCESS, 
+ false, false, false); 
+ 
+ ep->state.retry_counter--; 
+ } else { 
+ /* 
+ * TODO: start ping protocol per 5.2.2, if 
+ * successful reset timer and retries. For now 
+ * we just treat as if failed. 
+ */ 
+ ep->active_transfer->state.transfer_error = 
+ true; 
+ return -ETIMEDOUT; 
+ } 
+ 
+ ep->tx_timed_out = false; 
+ } 
+ 
+ /* put thread to sleep to wait for next timeout event */ 
+ wait_event_interruptible(ep->host_ep_wq, 
+ kthread_should_stop() || ep->tx_timed_out); 
+ } 
+ 
+ return 0; 
+} 
+ 
+ 
+/*-------------------------IN transfer ------------------------*/ 
+ 
+/** 
+ * Device-side IN transfer initialization process. 
+ * 
+ * @ tx_state: Transfer state to be initialized. 
+ * @ ep_state: Endpoint state to be initialized. 
+ * @ tx_req: TransferReq packet from host that intiated transfer. 
+ * 
+ * Called every time a transferReq packet is received. Initializes transfer 
+ * management variables. 
+ */ 
+void device_init_IN_transfer(struct mausb_transfer_state *tx_state, 
+ struct mausb_ep_state *ep_state, struct mausb_pkt *tx_req) 
+{ 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ 
+ tx_state->transfer_error = false; 
+ tx_state->transfer_complete = false; 
+ tx_state->rem_size = le32_to_cpu(tx_req->data->remaining_size_credit); 
+ 
+ ep_state->keep_alive_timer = MAUSB_TRANSFER_KEEP_ALIVE; 
+ ep_state->retry_counter = MAUSB_BULK_TRANSFER_RETRIES; 
+ ep_state->earliest_unacked = le32_to_cpu(tx_req->data->seq_num); 
+ ep_state->active_request_id = tx_req->data->req_id; 
+ ep_state->request_id++; 
+ 
+ ep->actual_length = 0; 
+ 
+ /* free old buffer if not previously freed */ 
+ if (ep->buffer) 
+ kfree(ep->buffer); 
+ 
+ /* alocate new buffer for this transfer */ 
+ ep->buffer = kzalloc(tx_state->rem_size, GFP_ATOMIC); 
+} 
+ 
+/* Determines if packet request id or sequence number is outside of the 
+ * acceptable range 
+ * 
+ * Returns true if the packet sequence number or request id is invalid, 
+ * otherwise returns false. 
+ */ 
+bool is_invalid_IN_request(struct mausb_ep_state *ep_state, 
+ struct mausb_pkt *tx_req) 
+{ 
+ u8 r = tx_req->data->req_id; 
+ u32 SN = le32_to_cpu(tx_req->data->seq_num); 
+ bool invalid = false; 
+ struct mausb_udc *udc = mausb_host_ep_to_maudc( 
+ mausb_state_to_ep(ep_state)); 
+ 
+ if ((ep_state->earliest_request_id - MAUSB_HALF_REQ_ID) <= r) { 
+ if (r < ep_state->earliest_request_id) { 
+ maudc_err(udc, "%s: too many outstanding requests\n", 
+ __func__); 
+ invalid = true; 
+ } 
+ } 
+ 
+ if ((ep_state->earliest_unacked - MAUSB_HALF_SEQ_NUM) <= SN) { 
+ if (SN < ep_state->earliest_unacked) { 
+ maudc_err(udc, "%s: too many unacknowledged packets\n", 
+ __func__); 
+ invalid = true; 
+ } 
+ } 
+ 
+ if (ep_state->seq_number < SN) { 
+ if (SN < (ep_state->seq_number + MAUSB_HALF_SEQ_NUM)) { 
+ maudc_err(udc, "%s: too many outstanding sequence" 
+ " numbers\n", __func__); 
+ invalid = true; 
+ } 
+ 
+ } 
+ 
+ return invalid; 
+} 
+ 
+/* 
+ * transferReq reception process outlined in MA USB spec. 
+ */ 
+int device_IN_rcvd_txReq(struct mausb_ep_state *ep_state, 
+ struct mausb_transfer_state *tx_state, 
+ struct mausb_pkt *tx_req) 
+{ 
+ u8 r = tx_req->data->req_id; 
+ u32 SN = le32_to_cpu(tx_req->data->seq_num); 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ struct mausb_udc *udc = mausb_host_ep_to_maudc(ep); 
+ 
+ if (is_invalid_IN_request(ep_state, tx_req)) { 
+ mausb_drop_packet(ep, tx_req); 
+ device_IN_send_null_txResp(ep, ep_state->request_id, 
+ INVALID_REQUEST); 
+ } 
+ 
+ ep_state->earliest_unacked = SN; 
+ 
+ if (tx_state->eot_detected && !tx_state->transfer_error) { 
+ if (tx_state->last_transfer_sn < SN) 
+ tx_state->transfer_complete = true; 
+ else 
+ ep_state->earliest_request_id = r; 
+ } 
+ 
+ if (r == ep_state->active_request_id && ep_state->delayed) { 
+ maudc_dbg(udc, "%s: transfer %i is delayed, sending txResp with" 
+ " status = TRANSFER_PENDING\n", __func__, r); 
+ device_IN_send_null_txResp(ep, r, TRANSFER_PENDING); 
+ } 
+ 
+ if (r == ep_state->request_id) 
+ device_init_IN_transfer(tx_state, ep_state, tx_req); 
+ 
+ return 0; 
+} 
+ 
+/* transferAck packet reception process for device side. 
+ * 
+ * @tx_state: Transfer state variables for associated transfer. 
+ * @ep_state: Endpoint state variables for associated transfer. 
+ * @tx_ack: TransferAck packet being received. 
+ * 
+ * Called when device side driver receives a transferAck packet. Caller should 
+ * verify that the request_id in the transferAck packet is valid before 
+ * calling this function. 
+ */ 
+int device_IN_ack_rcvd(struct mausb_transfer_state *tx_state, 
+ struct mausb_ep_state *ep_state, struct mausb_pkt *tx_ack) 
+{ 
+ int ret = 0; 
+ u8 r = tx_ack->data->req_id; 
+ u8 u = ep_state->active_request_id; 
+ u32 SN = le32_to_cpu(tx_ack->data->seq_num); 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ struct mausb_udc *udc = mausb_host_ep_to_maudc(ep); 
+ bool tx_complete = (!tx_state->transfer_error) 
+ && (tx_state->last_transfer_sn < SN); 
+ bool tx_complete_with_error = 
+ (tx_state->transfer_error) && (u == r); 
+ unsigned long irq_flags = 0; 
+ 
+ if (is_invalid_IN_request(ep_state, tx_ack)) 
+ tx_ack->data->common.pkt_status = DROPPED_PACKET; 
+ 
+ switch (tx_ack->data->common.pkt_status) { 
+ case DROPPED_PACKET: 
+ maudc_dbg(udc, "%s: status = DROPPED_PACKET\n", __func__); 
+ mausb_drop_packet(ep, tx_ack); 
+ break; 
+ case TRANSFER_PENDING: 
+ maudc_dbg(udc, "%s: status = TRANSFER_PENDING\n", __func__); 
+ if (r != ep_state->active_request_id) 
+ mausb_drop_packet(ep, tx_ack); 
+ /* else can start power saving measures */ 
+ break; 
+ case MISSING_SEQUENCE_NUMBER: 
+ maudc_dbg(udc, "%s: status = MISSING_SEQUENCE_NUMBER\n", 
+ __func__); 
+ mausb_resend_multi_packets(ep, &ep->resp_list, 
+ le32_to_cpu(tx_ack->data->seq_num), irq_flags); 
+ break; 
+ case SUCCESS: 
+ maudc_dbg(udc, "%s: status = SUCCESS\n", __func__); 
+ ep_state->earliest_unacked = SN + 1; 
+ 
+ if (tx_state->eot_detected) { 
+ if (tx_complete || tx_complete_with_error) 
+ tx_state->transfer_complete = true; 
+ else 
+ ep_state->earliest_request_id = u; 
+ 
+ mausb_cleanup_ma_packets(ep, 
+ le32_to_cpu(tx_ack->data->seq_num), 
+ tx_ack->data->req_id); 
+ kfree(ep->buffer); 
+ } 
+ break; 
+ default: 
+ break; 
+ } 
+ 
+ return ret; 
+} 
+ 
+/* Submit a transferResp packet to host with no payload (used for errors). 
+ * 
+ * Per spec, sequence number field in a null transferResp packet is always 
+ * reserved and set to 0 
+ */ 
+int device_IN_send_null_txResp(struct mausb_host_ep *ep, u8 req_id, int status) 
+{ 
+ struct mausb_pkt *tx_resp; 
+ struct mausb_transfer_state *tx_state = &ep->active_transfer->state; 
+ 
+ tx_resp = mausb_create_dp(NULL, ep->active_transfer, MAUSB_IN, 
+ MAUSB_DEV, GFP_ATOMIC); 
+ 
+ if (!tx_resp) 
+ return -ENOMEM; 
+ 
+ list_add_tail(&tx_resp->pkt_list, &ep->resp_list); 
+ 
+ mausb_fill_pkt_ep(tx_resp, ep); 
+ 
+ tx_resp->data->common.pkt_type = TransferResp; 
+ tx_resp->data->req_id = req_id; 
+ tx_resp->data->seq_num = 0; 
+ tx_resp->buffer_length = 0; 
+ tx_resp->data->remaining_size_credit = cpu_to_le32(tx_state->rem_size); 
+ tx_resp->data->common.pkt_status = status; 
+ tx_resp->common->length = cpu_to_le32(mausb_pkt_length(tx_resp)); 
+ 
+ mausb_transfer_data_pkt(tx_resp, ep, GFP_ATOMIC); 
+ 
+ return 0; 
+} 
+ 
+/** 
+ * Submit a transferResp packet with payload to host (normal data transfer). 
+ */ 
+int device_IN_send_txResp_with_payload(struct mausb_host_ep *ep) 
+{ 
+ int payload = 0; 
+ int max_buffer_length = 0; 
+ int ep_rem_size = ep->actual_length; 
+ struct mausb_ep_state *ep_state = &ep->state; 
+ struct mausb_transfer_state *tx_state = &ep->active_transfer->state; 
+ struct mausb_pkt *tx_resp; 
+ struct mausb_udc *udc = mausb_host_ep_to_maudc(ep); 
+ 
+ while (ep_rem_size > 0 || ep_state->seq_number == 0) { 
+ 
+ tx_resp = mausb_create_dp(NULL, ep->active_transfer, MAUSB_IN, 
+ MAUSB_DEV, GFP_ATOMIC); 
+ 
+ if (!tx_resp) 
+ return -ENOMEM; 
+ 
+ list_add_tail(&tx_resp->pkt_list, &ep->resp_list); 
+ 
+ mausb_fill_pkt_ep(tx_resp, ep); 
+ 
+ tx_resp->data->common.pkt_type = TransferResp; 
+ tx_resp->data->req_id = ep_state->active_request_id; 
+ tx_resp->data->seq_num = cpu_to_le32(ep_state->seq_number); 
+ tx_resp->data->remaining_size_credit = 
+ cpu_to_le32(tx_state->rem_size); 
+ 
+ max_buffer_length = 
+ MAUSB_MAX_PACKET_SIZE - sizeof(tx_resp->data); 
+ 
+ if (max_buffer_length <= 0) { 
+ maudc_err(udc, "%s: packet buffer error: length" 
+ " = %i\n", __func__, max_buffer_length); 
+ } else if (tx_state->rem_size <= 0) { 
+ maudc_err(udc, "%s: packet buffer error: rem_size" 
+ " = %i\n", __func__, tx_state->rem_size); 
+ ep->buffer = NULL; 
+ } else { 
+ payload = min_t(int, max_buffer_length, 
+ ep_rem_size); 
+ } 
+ 
+ tx_resp->buffer = ep->buffer; 
+ tx_resp->buffer_length = payload; 
+ tx_resp->common->length = cpu_to_le16(mausb_pkt_length(tx_resp)); 
+ 
+ /* note: setting ARQ flag for error is optional */ 
+ if (tx_state->transfer_error) { 
+ maudc_err(udc, "%s: transfer error with %i bytes " 
+ "remaining\n", __func__, tx_state->rem_size); 
+ 
+ tx_resp->data->eps_tflags |= MAUSB_PKT_TFLAG_EOT; 
+ tx_resp->data->eps_tflags |= MAUSB_PKT_TFLAG_ARQ; 
+ tx_resp->data->common.pkt_status = UNSUCCESSFUL; 
+ 
+ /* 
+ * TODO: take corrective action - e.g. clear all 
+ * transfers and restart endpoint 
+ */ 
+ } 
+ 
+ tx_state->rem_size -= payload; 
+ ep_rem_size -= payload; 
+ /* note: setting ARQ flag for completion is optional */ 
+ if (tx_state->rem_size == 0 || ep_rem_size == 0) { 
+ tx_resp->data->eps_tflags |= MAUSB_PKT_TFLAG_EOT; 
+ tx_resp->data->eps_tflags |= MAUSB_PKT_TFLAG_ARQ; 
+ tx_resp->data->common.pkt_status = SUCCESS; 
+ 
+ ep_state->active_request_id++; 
+ } 
+ 
+ maudc_dbg(udc, "%s: sending transferResp packet with sequence" 
+ " number %i for tranfer %i with %i bytes\n", __func__, 
+ le32_to_cpu(tx_resp->data->seq_num), 
+ le32_to_cpu(tx_resp->data->req_id), payload); 
+ 
+ mausb_transfer_data_pkt(tx_resp, ep, GFP_ATOMIC); 
+ 
+ ep_state->seq_number++; 
+ 
+ } 
+ 
+ return 0; 
+} 
+ 
+/*------------------ protocol-managed OUT transfer --------------------*/ 
+ 
+bool should_drop_OUT_txReq(struct mausb_ep_state *ep_state, 
+ struct mausb_transfer_state *tx_state, struct mausb_pkt *tx_req) 
+{ 
+ u8 r = tx_req->data->req_id; 
+ u32 SN = le32_to_cpu(tx_req->data->seq_num); 
+ int payload_size = tx_req->buffer_length; 
+ int status = SUCCESS; 
+ bool drop = false; 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ struct mausb_udc *udc = mausb_host_ep_to_maudc(ep); 
+ 
+ if (SN > ep_state->seq_number) { 
+ maudc_err(udc, "%s: sequence number %i is too large " 
+ "(expected < %i)\n", __func__, SN, 
+ ep_state->seq_number); 
+ drop = true; 
+ status = MISSING_SEQUENCE_NUMBER; 
+ } else if (SN < ep_state->seq_number) { 
+ /* per spec, don't have to send response for this case */ 
+ maudc_err(udc, "%s: sequence number %i is too small " 
+ "(expected >= %i)\n", __func__, SN, 
+ ep_state->seq_number); 
+ drop = true; 
+ } else if (r < ep_state->earliest_request_id) { 
+ maudc_err(udc, "%s: request ID %i is too small " 
+ "(expected > %i)\n", __func__, r, 
+ ep_state->earliest_request_id); 
+ drop = true; 
+ status = INVALID_REQUEST; 
+ } else if (r > ep_state->request_id) { 
+ /* account for wraparound */ 
+ if (ep_state->request_id != 0 && r != MAUSB_MAX_REQ_ID) { 
+ maudc_err(udc, "%s: request ID %i is too large " 
+ "(expected < %i)\n", __func__, r, 
+ ep_state->request_id); 
+ drop = true; 
+ status = INVALID_REQUEST; 
+ } 
+ } else if ((payload_size + ep_state->occupancy) 
+ > ep_state->rx_buf_size) { 
+ maudc_err(udc, "%s: payload (%i bytes) is too large for buffer" 
+ " (%i bytes)\n", __func__, payload_size, 
+ ep_state->occupancy); 
+ drop = true; 
+ status = TRANSFER_DATA_BUFFER_ERROR; 
+ } 
+ 
+ /* 
+ * send txResp to host with appropriate status if txReq is going to 
+ * get dropped 
+ */ 
+ if (status) { 
+ device_OUT_send_txResp(tx_state, ep_state, 
+ ep_state->request_id, ep_state->seq_number, status, 
+ false, false, false); 
+ } 
+ 
+ return drop; 
+} 
+ 
+/** 
+ * Handles receipt of a transferRequest packet. 
+ * 
+ * @tx_state: State variables for associated transfer. 
+ * @ep_state: State variables for associated device endpoint. 
+ * @tx_req: TransferRequest packet being received. 
+ */ 
+int device_OUT_txReq_rcvd(struct mausb_transfer_state *tx_state, 
+ struct mausb_ep_state *ep_state, struct mausb_pkt *tx_req) 
+{ 
+ u8 req_id = tx_req->data->req_id; 
+ u32 SN = le32_to_cpu(tx_req->data->seq_num); 
+ int ret = 0; 
+ int payload_size = tx_req->buffer_length; 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ struct mausb_udc *udc = mausb_host_ep_to_maudc(ep); 
+ 
+ maudc_dbg(udc, "%s: received transferReq packet %i for transfer %i\n", 
+ __func__, SN, req_id); 
+ 
+ if (should_drop_OUT_txReq(ep_state, tx_state, tx_req)) { 
+ maudc_err(udc, "%s: dropping packet %i\n", __func__, SN); 
+ mausb_drop_packet(ep, tx_req); 
+ return 0; 
+ } 
+ 
+ /* start new transfer */ 
+ if (req_id == (ep_state->request_id)) { 
+ tx_state->transfer_error = false; 
+ tx_state->transfer_complete = false; 
+ tx_state->eot_detected = false; 
+ tx_state->rem_size = 
+ le32_to_cpu(tx_req->data->remaining_size_credit); 
+ tx_state->payload_size = 0; 
+ ep->active_transfer->transfer_size = tx_state->rem_size; 
+ ep_state->active_request_id = req_id; 
+ INIT_LIST_HEAD(&ep->req_list); 
+ INIT_LIST_HEAD(&ep->resp_list); 
+ 
+ ep->actual_length = 0; 
+ 
+ ep_state->request_id = 
+ mausb_req_id_add(ep_state->request_id, 1); 
+ } 
+ 
+ ep->buffer = tx_req->buffer; 
+ ep_state->occupancy += payload_size; 
+ ret = device_OUT_deliver_payload(tx_req, ep_state, tx_state); 
+ ep_state->occupancy -= payload_size; 
+ 
+ ep_state->seq_number++; 
+ 
+ return 0; 
+} 
+ 
+/** 
+ * Transmits a transferReq or transferAck packet. 
+ */ 
+int device_OUT_send_txResp(struct mausb_transfer_state *tx_state, 
+ struct mausb_ep_state *ep_state, u32 req_id, u32 seq_num, 
+ int status, bool retry, bool eot, bool arq) 
+{ 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ struct mausb_pkt *tx_resp = mausb_create_dp(NULL, ep->active_transfer, 
+ MAUSB_OUT, MAUSB_DEV, GFP_ATOMIC); 
+ struct mausb_udc *udc = mausb_host_ep_to_maudc(ep); 
+ 
+ if (!tx_resp) 
+ return -ENOMEM; 
+ 
+ mausb_fill_pkt_ep(tx_resp, ep); 
+ 
+ tx_resp->data->common.pkt_type = TransferResp; 
+ tx_resp->data->req_id = req_id; 
+ tx_resp->data->seq_num = cpu_to_le32(seq_num); 
+ tx_resp->data->common.pkt_status = status; 
+ tx_resp->data->remaining_size_credit = 
+ cpu_to_le32(ep_state->rx_buf_size - ep_state->occupancy); 
+ 
+ list_add_tail(&tx_resp->pkt_list, &ep->resp_list); 
+ 
+ 
+ tx_resp->common->length = cpu_to_le16(mausb_pkt_length(tx_resp)); 
+ 
+ if (retry) 
+ tx_resp->common->ver_flags |= MAUSB_PKT_FLAG_RETRY; 
+ 
+ if (eot) 
+ tx_resp->data->eps_tflags |= MAUSB_PKT_TFLAG_EOT; 
+ 
+ if (arq) 
+ tx_resp->data->eps_tflags |= MAUSB_PKT_TFLAG_ARQ; 
+ 
+ maudc_dbg(udc, "%s: sending transferResp packet %i for transfer %i\n", 
+ __func__, le32_to_cpu(tx_resp->data->seq_num), 
+ tx_resp->data->req_id); 
+ 
+ /* send transferResp packet to host */ 
+ mausb_transfer_data_pkt(tx_resp, ep, GFP_ATOMIC); 
+ 
+ return 0; 
+} 
+ 
+/** 
+ * Handles receipt of a transferAck packet. 
+ * 
+ * Caller should ensure that transfer complete and error flags are not set. 
+ * Note that what to do isn't defined in spec - we are on our own for this one! 
+ */ 
+void device_OUT_ack_rcvd(struct mausb_transfer_state *tx_state, 
+ struct mausb_ep_state *ep_state, 
+ struct mausb_pkt *tx_ack) 
+{ 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ struct mausb_udc *udc = mausb_host_ep_to_maudc(ep); 
+ 
+ maudc_dbg(udc, "%s: received transferAck packet for transfer %i\n", 
+ __func__, tx_ack->data->req_id); 
+ 
+ ep_state->occupancy = 0; 
+ mausb_cleanup_ma_packets(ep, le32_to_cpu(tx_ack->data->seq_num), 
+ tx_ack->data->req_id); 
+} 
+ 
+/* 
+ * Copy payload from transferRequest into device buffer. 
+ * 
+ * @tx_req: TransferRequest with payload to be delivered. 
+ * @ep_state: State variables for associated device endpoint. 
+ * @tx_state: State variables for associated transfer. 
+ * 
+ * Caller should ensure that transfer complete and error flags are not set. 
+ * This function also includes payload delivery process outlined in spec. 
+ */ 
+int device_OUT_deliver_payload(struct mausb_pkt *tx_req, 
+ struct mausb_ep_state *ep_state, 
+ struct mausb_transfer_state *tx_state) 
+{ 
+ u32 req_sn = le32_to_cpu(tx_req->data->seq_num); 
+ int payload_size; 
+ struct mausb_host_ep *ep = mausb_state_to_ep(ep_state); 
+ struct mausb_udc *udc = mausb_host_ep_to_maudc(ep); 
+ 
+ /* payload delivery process */ 
+ payload_size = do_ma_transfer(ep, tx_req, MAUSB_OUT); 
+ 
+ /* payload delivery confirmation process */ 
+ if (payload_size < 0) { 
+ maudc_err(udc, "%s: transfer error %i\n", __func__, 
+ payload_size); 
+ 
+ device_OUT_send_txResp(tx_state, ep_state, tx_req->data->req_id, 
+ le32_to_cpu(tx_req->data->seq_num), UNSUCCESSFUL, 
+ false, true, false); 
+ } 
+ 
+ else { 
+ ep_state->earliest_unacked = req_sn + 1; 
+ tx_state->payload_size = payload_size - tx_state->payload_size; 
+ tx_state->rem_size = 
+ le32_to_cpu(tx_req->data->remaining_size_credit); 
+ tx_state->payload_size = payload_size; 
+ 
+ maudc_dbg(udc, "%s: delivered %i bytes with %i remaining\n", 
+ __func__, payload_size, tx_state->rem_size); 
+ 
+ /* control response packet */ 
+ if (tx_req->setup) { 
+ device_OUT_send_txResp(tx_state, ep_state, 
+ tx_req->data->req_id, 
+ le32_to_cpu(tx_req->data->seq_num), 
+ SUCCESS, false, true, true); 
+ 
+ /* end of transfer response packet */ 
+ } else if (tx_state->rem_size == 0) { 
+ tx_state->last_transfer_sn = req_sn; 
+ 
+ device_OUT_send_txResp(tx_state, ep_state, 
+ tx_req->data->req_id, 
+ le32_to_cpu(tx_req->data->seq_num), 
+ SUCCESS, false, true, true); 
+ } else if (tx_req->data->eps_tflags & MAUSB_PKT_TFLAG_ARQ) { 
+ device_OUT_send_txResp(tx_state, ep_state, 
+ tx_req->data->req_id, 
+ le32_to_cpu(tx_req->data->seq_num), 
+ SUCCESS, false, false, true); 
+ } 
+ } 
+ 
+ return 0; 
+} 
+ 
+/*------------------ transfer interfaces ----------------------------*/ 
+ 
+/** 
+ * Called to receive both transferRequest and transferAck packets. 
+ * For transferRequests, a new transfer is initiated - transfer state values 
+ * are initialized and a request is send to the device to get data. For 
+ * transferAcks, a transfer is ended (either successfully or with error, 
+ * depending on transferAck packet status). 
+ */ 
+int receive_ma_packet_IN(struct ms_pkt *ms_pkt, void *context) 
+{ 
+ int ret = 0; 
+ struct mausb_host_ep *ep; 
+ struct mausb_pkt *pkt; 
+ struct mausb_udc *udc; 
+ 
+ if ((NULL == context) || (NULL == ms_pkt)) { 
+ pr_err("%s: received NULL %s\n", __func__, 
+ context ? "packet" : "context"); 
+ return -EFAULT; 
+ } 
+ 
+ ep = (struct mausb_host_ep *) context; 
+ del_timer(&ep->timer); 
+ 
+ pkt = mausb_pkt_from_ms_pkt_ep(ms_pkt, ep, GFP_ATOMIC); 
+ list_add_tail(&pkt->pkt_list, &ep->req_list); 
+ 
+ udc = mausb_host_ep_to_maudc(ep); 
+ 
+ if (mausb_is_a_retry(ep, &ep->resp_list, pkt)) 
+ return 0; 
+ 
+ switch (pkt->data->common.pkt_type) { 
+ case TransferReq: 
+ maudc_dbg(udc, "%s: received transferReq %i for transfer %i\n", 
+ __func__, le32_to_cpu(pkt->data->seq_num), 
+ pkt->data->req_id); 
+ device_IN_rcvd_txReq(&ep->state, &ep->active_transfer->state, 
+ pkt); 
+ ret = do_ma_transfer(ep, pkt, MAUSB_IN); 
+ ret = device_IN_send_txResp_with_payload(ep); 
+ break; 
+ case TransferAck: 
+ maudc_dbg(udc, "%s: received transferAck for transfer %i\n", 
+ __func__, pkt->data->req_id); 
+ ret = device_IN_ack_rcvd(&ep->active_transfer->state, 
+ &ep->state, pkt); 
+ break; 
+ default: 
+ maudc_err(udc, "%s: invalid packet type/subtype %i\n", 
+ __func__, pkt->data->common.pkt_type); 
+ ret = -EINVAL; 
+ } 
+ 
+ return ret; 
+} 
+ 
+/** 
+ * Receives both transferReq and transferAck packets for OUT transfers. When a 
+ * packet is received, it is put on a list for handling. If the endpoint is not 
+ * already handling a packet, it starts iterating through the list of received 
+ * packets. 
+ */ 
+int receive_ma_packet_OUT(struct ms_pkt *ms_pkt, void *context) 
+{ 
+ int ret = 0; 
+ struct mausb_host_ep *ep; 
+ struct mausb_pkt *pkt; 
+ struct mausb_udc *udc; 
+ 
+ if ((NULL == context) || (NULL == ms_pkt)) { 
+ pr_err("%s: received NULL %s\n", __func__, 
+ context ? "packet" : "context"); 
+ return -EFAULT; 
+ } 
+ 
+ ep = (struct mausb_host_ep *) context; 
+ del_timer(&ep->timer); 
+ 
+ pkt = mausb_pkt_from_ms_pkt_ep(ms_pkt, ep, GFP_ATOMIC); 
+ list_add_tail(&pkt->pkt_list, &ep->req_list); 
+ 
+ udc = mausb_host_ep_to_maudc(ep); 
+ 
+ if (mausb_is_a_retry(ep, &ep->resp_list, pkt)) 
+ return 0; 
+ 
+ /* determine if packet is a transferRequest */ 
+ if (pkt->data->common.pkt_type == TransferReq) { 
+ maudc_dbg(udc, "%s: received transferReq %i for transfer %i\n", 
+ __func__, le32_to_cpu(pkt->data->seq_num), 
+ pkt->data->req_id); 
+ ret = device_OUT_txReq_rcvd(&ep->active_transfer->state, 
+ &ep->state, pkt); 
+ 
+ /* if not a transferReq, it should be a transferAck */ 
+ } else if (pkt->data->common.pkt_type == TransferAck) { 
+ maudc_dbg(udc, "%s: received transferAck for transfer %i\n", 
+ __func__, pkt->data->req_id); 
+ device_OUT_ack_rcvd(&ep->active_transfer->state, &ep->state, 
+ pkt); 
+ } else { 
+ /* TODO: deal with invalid packet type */ 
+ } 
+ 
+ return ret; 
+} 
+ 
+/** 
+ * Called when a transferReq is received on a control endpoint. 
+ * 
+ * @ms_pkt: Packet being received. 
+ * @context: Device endpoint associated with transfer (this should always 
+ * be ep0). 
+ */ 
+int receive_ma_packet_control(struct ms_pkt *ms_pkt, void *context) 
+{ 
+ int ret = 0; 
+ struct mausb_host_ep *ep; 
+ struct mausb_pkt *pkt; 
+ struct mausb_udc *udc; 
+ 
+ if ((NULL == context) || (NULL == ms_pkt)) { 
+ pr_err("%s: received NULL %s\n", __func__, 
+ context ? "packet" : "context"); 
+ return -EFAULT; 
+ } 
+ 
+ ep = (struct mausb_host_ep *) context; 
+ del_timer(&ep->timer); 
+ 
+ pkt = mausb_pkt_from_ms_pkt_ep(ms_pkt, ep, GFP_ATOMIC); 
+ udc = mausb_host_ep_to_maudc(ep); 
+ 
+ /* 
+ * A new control transfer begins with a transfer request carrying setup 
+ * data and sequence number 0. 
+ */ 
+ if (pkt->setup) { 
+ ep->state.seq_number = 0; 
+ ep->actual_length = 0; 
+ ep->active_transfer->state.rem_size = 
+ le32_to_cpu(pkt->data->remaining_size_credit); 
+ 
+ /* 
+ * Determine if this is a control IN or OUT - if there is data 
+ * in the packet, or the host is requesting no data, we are 
+ * an OUT. 
+ */ 
+ if (0 != pkt->buffer_length || 
+ 0 == le32_to_cpu(pkt->data->remaining_size_credit)) { 
+ 
+ ep->control_dir = MAUSB_OUT; 
+ 
+ } else 
+ ep->control_dir = MAUSB_IN; 
+ } 
+ 
+ kfree(pkt); 
+ pkt = NULL; 
+ 
+ if (MAUSB_IN == ep->control_dir) 
+ ret = receive_ma_packet_IN(ms_pkt, context); 
+ else 
+ ret = receive_ma_packet_OUT(ms_pkt, context); 
+ 
+ return ret; 
+} 
+ 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/staging/mausb/drivers/mausb_tx.h linux-linaro-3.4-2012.05-1_cavium/drivers/staging/mausb/drivers/mausb_tx.h
